unit WaitUnF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  ComCtrls;


type
  TWaitForm = class(TForm)
    Panel1: TPanel;
    Panel: TPanel;
    RxLabel1: TLabel;
    ProgressBar: TProgressBar;
    AnimateGlobe: TAnimate;
    Bevel2: TBevel;
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  protected
    FirstHeight:integer;
    procedure MakePos; virtual;
  public
    { Public declarations }
    procedure ShowProgress; virtual;
    procedure HideProgress; virtual;
//    constructor CreateMSG(AOwner:TComponent;MSG :String); virtual;
    constructor Create(AOwner:TComponent); override;
  end;

var
  WaitForm: TWaitForm;

  AviActive:boolean;

implementation

{$R *.DFM}


constructor TWaitForm.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
// RXLabel1.Caption:=MSG;
 FirstHeight:=Height;

// AnimateGlobe.ResName:='WAITGLOBE';
// AnimateGlobe.Transparent:=true;

// AnimateGlobe.ResName:='WAITGLOBE1';
// AnimateGlobe.Transparent:=false;

 if AviActive then  AnimateGlobe.Active:=true;

 MakePos;
end;

procedure TWaitForm.ShowProgress;
begin
//  ClientHeight:=ProgressBar.Top+ProgressBar.Height*2;
  ProgressBar.Visible:=true;
  Refresh;
end;

procedure TWaitForm.HideProgress;
begin
//  Height:=FirstHeight;
  ProgressBar.Visible:=false;
  Refresh;
end;

procedure TWaitForm.MakePos;
begin
;  //   -     
end;

procedure TWaitForm.FormDestroy(Sender: TObject);
begin
   if AnimateGlobe.Active then AnimateGlobe.Active:=true;
end;

initialization

  AviActive:=true;

end.
