unit ConfirmUnit1;
{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, ExtCtrls;

const cftPrinter:string='Print?';
      cfButtOk='Printer';
      cfButtCancel='Monitor';

type
  TConfirmForm2 = class(TForm)
    LabelText: TLabel;
    BitBtnOk: TBitBtn;
    BitBtnCancel: TBitBtn;
    BitBtnIgnore: TBitBtn;
    Bevel1: TBevel;
    Bevel2: TBevel;
    WarningImage: TImage;
  private
    { Private declarations }
  public
    { Public declarations }
  end;


function GetConfirm(Text:String):TModalResult;
function GetConfirmSmall(Text:string):TModalResult;
//function GetRepoConfirm(Text:String;var ThCount:integer):TModalResult;
function GetConfirmAll(Text:String):TModalResult;

var
  ConfirmForm2: TConfirmForm2;

implementation

{$R *.DFM}


function GetConfirm(Text:String):TModalResult;
var ConfForm:TConfirmForm2;
begin
  ConfForm:=TConfirmForm2.Create(Application);
  try
    if trim(Text)<>'' then ConfForm.LabelText.Caption:=Text;
    result:=ConfForm.ShowModal;
  finally
     ConfForm.free;
  end;
  Application.ProcessMessages;
end;

function GetConfirmAll(Text:String):TModalResult;
var ConfForm:TConfirmForm2;
begin
  ConfForm:=TConfirmForm2.Create(Application);
  try
    if trim(Text)<>'' then ConfForm.LabelText.Caption:=Text;
    ConfForm.BitBtnIgnore.Caption:='Yes, for all!';
    result:=ConfForm.ShowModal;
  finally
    ConfForm.free;
  end;
  Application.ProcessMessages;
end;

function GetConfirmSmall(Text:String):TModalResult;
var ConfForm:TConfirmForm2;
begin
  ConfForm:=TConfirmForm2.Create(Application);
  try
    if trim(Text)<>'' then ConfForm.LabelText.Caption:=Text;
    ConfForm.clientHeight:=ConfForm.BitBtnIgnore.Top ; //+ConfForm.BitBtnIgnore.Height div 2+ConfForm.Height-ConfForm.ClientHeight;
    Confform.BitBtnIgnore.Visible:=false;
    result:=ConfForm.ShowModal;
  finally
     ConfForm.free;
  end;
  Application.ProcessMessages;
end;

end.
