{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}
unit EditShapeUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  quickrpt, Qrctrls, StdCtrls, Buttons;

type
  TEditShapeForm = class(TForm)
    Label1: TLabel;
    EditShapeType: TComboBox;
    SeeImage: TQRShape;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure EditShapeTypeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetImage;
  end;

var
  EditShapeForm: TEditShapeForm;

implementation

{$R *.DFM}

procedure TEditShapeForm.EditShapeTypeChange(Sender: TObject);
begin
  SetImage;
end;

procedure TEditShapeForm.SetImage;
begin
  SeeImage.Shape:=TQRShapeType(EditShapeType.ItemIndex);
  SeeImage.Repaint;
end;

end.
