unit MessUnit;
{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TMessForm = class(TForm)
    LabMess: TLabel;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    Bevel1: TBevel;
    Bevel2: TBevel;
    PanelRight: TPanel;
    PanelLeft: TPanel;
    StopImage: TImage;
    StopImage1: TImage;
    InfoImage: TImage;
    BitBtn2: TBitBtn;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure bvMessError(Mess:string);
procedure bvMess(Mess:string;CapString:string='!!!');


var
  MessForm: TMessForm;

implementation

{$R *.DFM}

procedure bvMess(Mess:string;CapString:string='!!!');
begin
  with TMessForm.create(Application) do
  try
    Caption:=CapString;
    LabMess.CAption:=Mess;
    ShowModal;
  finally
    free;
  end;
end;

procedure bvMessError(Mess:string);
begin
  with TMessForm.create(Application) do
  try
    Caption:='Error!';
    LabMess.CAption:=Mess;
    StopImage.Visible:=true;
    InfoImage.Visible:=false;
//    PanelLeft.Width:=InfoImage;
//    StopImage1.Visible:=true;
    ShowModal;
  finally
    free;
  end;
end;

end.
