unit WaitUnF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  ComCtrls;


type
  TWaitForm = class(TForm)
    Panel1: TPanel;
    Panel: TPanel;
    RxLabel1: TLabel;
    ProgressBar: TProgressBar;
    AnimateGlobe: TAnimate;
    Bevel2: TBevel;
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  protected
    FirstHeight:integer;
  public
    { Public declarations }
    procedure ShowProgress; virtual;
    procedure HideProgress; virtual;
    constructor Create(AOwner:TComponent); override;
  end;

var
  WaitForm: TWaitForm;

  AviActive:boolean;

implementation

{$R *.DFM}


constructor TWaitForm.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
 FirstHeight:=Height;


 if AviActive then  AnimateGlobe.Active:=true;

end;

procedure TWaitForm.ShowProgress;
begin
  ProgressBar.Visible:=true;
  Refresh;
end;

procedure TWaitForm.HideProgress;
begin
  ProgressBar.Visible:=false;
  Refresh;
end;

procedure TWaitForm.FormDestroy(Sender: TObject);
begin
   if AnimateGlobe.Active then AnimateGlobe.Active:=true;
end;

initialization

  AviActive:=true;

end.
