{*********************************************}
{*   RepoEdit -   QuickReport *}
{*    Delphi 4                          *}
{*   (C) Copyright                           *}
{*                             *}
{*********************************************}
unit EditBrushUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TEditBrushForm = class(TForm)
    BitBtnColor: TBitBtn;
    EditStyle: TComboBox;
    Label1: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    ColorDialog: TColorDialog;
    procedure BitBtnColorClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ThBrush:TBrush;
  end;

var
  EditBrushForm: TEditBrushForm;

implementation

{$R *.DFM}

procedure TEditBrushForm.BitBtnColorClick(Sender: TObject);
begin
  ColorDialog.Execute;
end;

procedure TEditBrushForm.FormShow(Sender: TObject);
begin
  ColorDialog.Color:=ThBrush.Color;
  EditStyle.ItemIndex:=ord(ThBrush.Style);
end;

procedure TEditBrushForm.BitBtn2Click(Sender: TObject);
begin
  ThBrush.Color:=ColorDialog.Color;
  ThBrush.Style:=TBrushStyle(EditStyle.ItemIndex);
end;

end.
