{*********************************************}
{*   RepoEdit -   QuickReport *}
{*    Delphi 4                          *}
{*   (C) Copyright                           *}
{*                             *}
{*********************************************}
unit EditPenUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons;

type
  TEditPenForm = class(TForm)
    BitBtnColor: TBitBtn;
    ColorDialog: TColorDialog;
    EditWidth: TSpinEdit;
    EditStyle: TComboBox;
    BitBtnOk: TBitBtn;
    BitBtnCANCEL: TBitBtn;
    EditMode: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure BitBtnColorClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ThPen:Tpen;
  end;

var
  EditPenForm: TEditPenForm;

implementation

{$R *.DFM}



procedure TEditPenForm.BitBtnColorClick(Sender: TObject);
begin
  ColorDialog.Execute;
end;

procedure TEditPenForm.FormShow(Sender: TObject);
begin
  ColorDialog.Color:=ThPen.Color;
  EditWidth.Value:=ThPen.Width;
  EditStyle.ItemIndex:=ord(ThPen.Style);
  EditMode.ItemIndex:=ord(ThPen.Mode);
end;

procedure TEditPenForm.BitBtnOkClick(Sender: TObject);
begin
  ThPen.Color:=ColorDialog.Color;
  ThPen.Width:=EditWidth.Value;
  ThPen.Style:=TPenStyle(EditStyle.ItemIndex);
  ThPen.Mode:=TPenMode(EditMode.ItemIndex);
end;

end.
