{*********************************************}
{*   RepoEdit -   QuickReport *}
{*    Delphi 4                          *}
{*   (C) Copyright                           *}
{*                             *}
{*********************************************}
unit PrinterSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  QuickRPT,QRCTRLS,QRPRNTR,
  printers, StdCtrls, Buttons, Spin;

type
  TPrinterSettingsForm = class(TForm)
    EditCopies: TSpinEdit;
    Label1: TLabel;
    EditDuplex: TCheckBox;
    Label2: TLabel;
    EditOutputBin: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    EditlastPage: TSpinEdit;
    EditFirstPage: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ThprinterSettings:TQuickRepPrinterSettings;
  end;

var
  PrinterSettingsForm: TPrinterSettingsForm;

implementation

{$R *.DFM}

procedure TPrinterSettingsForm.FormShow(Sender: TObject);
begin
  EditCopies.Value:=ThprinterSettings.Copies;
  EditDuplex.Checked:=ThprinterSettings.Duplex;
  EditFirstPage.Value:=ThprinterSettings.FirstPage;
  EditLastPage.Value:=ThprinterSettings.LastPage;
  EditOutputBin.ItemIndex:=ORD(ThprinterSettings.OutputBin);
end;

procedure TPrinterSettingsForm.BitBtn1Click(Sender: TObject);
begin
  ThprinterSettings.Copies:=EditCopies.Value;
  ThprinterSettings.Duplex:=EditDuplex.Checked;
  ThprinterSettings.FirstPage:=EditFirstPage.Value;
  ThprinterSettings.LastPage:=EditLastPage.Value;
  ThprinterSettings.OutputBin:=TQRBin(EditOutputBin.ItemIndex);
end;





end.
